"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const debug_1 = __importDefault(require("debug"));
const plugin_replace_1 = __importDefault(require("@rollup/plugin-replace"));
const utils_1 = require("./utils");
const defaultOptions = {
    devices: ['desktop', 'mobile'],
    replacement: (device) => ['DEVICE.' + device, 'window.DEVICE.' + device],
    resolvePath: (path, device) => path.replace(/\.([^?/\\]+)(\?.*)?$/, `.${device}.$1$2`),
    env: 'DEVICE'
};
const debug = debug_1.default('vite:multi-device');
function multiDevice(rawOptions) {
    const options = { ...defaultOptions, ...(rawOptions || {}) };
    let replacements, buildFor, replace;
    let config;
    function configResolved(_config) {
        config = _config;
        buildFor = config.__DEVICE || process.env[options.env];
        debug('building for "' + buildFor + '"');
        if (!buildFor || !options.devices.includes(buildFor)) {
            throw new Error('vite-plugin-multi-device: DEVICE is not specified or not listed in devices option: ' + buildFor);
        }
        replacements = options.devices.reduce((carry, item) => {
            [].concat(options.replacement(item)).forEach(id => {
                carry[id] = buildFor === item;
            });
            return carry;
        }, {});
        replace = plugin_replace_1.default({
            values: replacements,
        });
    }
    return [{
            name: 'vite:multi-device',
            enforce: 'pre',
            configResolved,
            resolveId(id) {
                const filePath = utils_1.idToFilePath(id, config.root);
                if (filePath) {
                    const deviceFilePath = options.resolvePath(filePath, buildFor);
                    if (fs.existsSync(deviceFilePath)) {
                        debug(`switch id: "${id}" -> "${deviceFilePath}"`);
                        return deviceFilePath;
                    }
                }
            },
            transform(code, id) {
                const newCode = replace.transform && replace.transform.call(this, code, id);
                if (newCode)
                    debug('transforming: ' + id);
                return newCode;
            },
        }];
}
exports.default = multiDevice;
