"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveDevice = void 0;
const cache = new Map();
function resolveDevice(req, devices) {
    const userAgent = req.headers['user-agent'] || '';
    const cached = cache.get(userAgent);
    if (cached) {
        return cached;
    }
    const result = Object.keys(devices).find(device => {
        const re = devices[device];
        if (typeof re === 'boolean') {
            return re;
        }
        if (typeof re === 'function') {
            return re(req);
        }
        return re.test(userAgent);
    });
    if (result)
        cache.set(userAgent, result);
    return result;
}
exports.resolveDevice = resolveDevice;
